#!/usr/bin/env python
#-*- coding: UTF-8 -*-

import wx
import os
from   .mumamisc import *

docstr = """With MusicMan - the Music Manager - you can:
> create a database of your archived music
> create nearly any possible query
> show and export query results
> start a media player of your choice playing your music
> save playlists of selected music files or complete query results

Frank Mersmann (design and coding) - fmersmann@gmail.com
Wolfgang Bredow (testing and hints) - bredow.w@t-online.de"""


class AboutDialog(wx.Dialog):
    def __init__(self, parent, sqliteversion):
        """ place About items on dialog """
        wx.Dialog.__init__(self, parent, -1, TITLE + ' - About')
        btnadj = int(parent.config['Misc']['norm'] == 'False')
        SQLITEVERSION = 'Sqlite database - Version %s' % sqliteversion
        sizer = wx.BoxSizer(wx.VERTICAL)
        sb = wx.StaticBox(self, -1, ' %s ' % VERSION)
        sbsz = wx.StaticBoxSizer(sb, wx.VERTICAL)

        row1 = wx.BoxSizer(wx.HORIZONTAL)
        png = wx.Image(ICONPATH + os.sep + 'musicman.png', wx.BITMAP_TYPE_PNG).ConvertToBitmap()
        bm = wx.StaticBitmap(self, -1, png, wx.Point(10, 10), (png.GetWidth(), png.GetHeight()))
        row1.Add(bm, 0, wx.RIGHT, BORDER)
        st = wx.StaticText(self, -1, '\n\n> release date - %s\n> %s\n> %s\n> %s\n> %s' % (RELEASEDATE, PYVERSION, WXVERSION, PLATFORMINFO, SQLITEVERSION),
                           pos = wx.Point(30 + png.GetWidth(), BORDER))
        row1.Add(st, 0, wx.LEFT, BORDER)
        sbsz.Add(row1, 0, wx.GROW | wx.ALL, BORDER)

        row2 = wx.BoxSizer(wx.HORIZONTAL)
        st = wx.StaticText(self, -1, docstr)
        row2.Add(st, 0, wx.LEFT | wx.RIGHT, BORDER)
        sbsz.Add(row2, 0, wx.GROW | wx.ALL, BORDER)
        sizer.Add(sbsz, 0, wx.GROW | wx.ALL, BORDER)

        row3 = wx.BoxSizer(wx.HORIZONTAL)
        if not btnadj: row3.AddStretchSpacer()
        butok = wx.Button(self, wx.ID_OK)
        row3.Add(butok, btnadj, wx.GROW | wx.LEFT | wx.RIGHT | wx.BOTTOM, GAP)

        sizer.Add(row3, 1,  wx.GROW | wx.LEFT | wx.RIGHT | wx.BOTTOM, GAP)
        self.SetSizer(sizer)
        self.Fit()
        self.Centre()
# - class AboutDialog(wx.Dialog):---------------------------------------------------------------
