#!/usr/bin/env python
#-*- coding: UTF-8 -*-

import wx
import os
from   .mumamisc import *

s1 = """You are about to delete record(s) from db.
Is it this, what you realy want to do?"""

s2= """You are about to delete record(s) from db AND
possibly delete associated music files from device!
Is it this, what you realy want to do?"""

class DeleteRecordDialog(wx.Dialog):
    def __init__(self, parent, withcheckbox):
        """ place About items on dialog """
        wx.Dialog.__init__(self, parent, -1, TITLE + ' - remove records [and files]')
        btnadj = int(parent.config['Misc']['norm'] == 'False') 
        sizer = wx.BoxSizer(wx.VERTICAL)
        row1 = wx.BoxSizer(wx.HORIZONTAL)
        png = wx.Image(ICONPATH + os.sep + 'delrecord.png', wx.BITMAP_TYPE_PNG).ConvertToBitmap()
        bm = wx.StaticBitmap(self, -1, png, wx.Point(10, 10), (png.GetWidth(), png.GetHeight()))
        row1.Add(bm, 0, wx.RIGHT, BORDER)
        if withcheckbox:
            s = s2
        else:
            s = s1
        st = wx.StaticText(self, -1, s, pos = wx.Point(30 + png.GetWidth(), BORDER))
        row1.Add(st, 0, wx.LEFT, BORDER)
        sizer.Add(row1, 0, wx.GROW | wx.ALL, BORDER)
        if withcheckbox:
            self.cbf = wx.CheckBox(self, -1, ' check to remove associated music file(s) from device') 
            sizer.Add(self.cbf, 0, wx.LEFT | wx.RIGHT, BORDER + GAP)

        sl = wx.StaticLine(self, -1)
        sizer.Add(sl, 0, wx.GROW | wx.TOP, BORDER)
        row3 = wx.BoxSizer(wx.HORIZONTAL)
        if not btnadj: row3.AddStretchSpacer()
        btremove = wx.Button(self, wx.ID_REMOVE)
        self.Bind(wx.EVT_BUTTON, self.onRemove, id = wx.ID_REMOVE)
        row3.Add(btremove, btnadj, wx.GROW | wx.ALL, GAP)        
        btcancel = wx.Button(self, wx.ID_CANCEL)
        row3.Add(btcancel, btnadj,  wx.GROW | wx.ALL, GAP)
        sizer.Add(row3, 1, wx.GROW | wx.ALL, GAP)
        self.SetSizer(sizer)
        self.Fit()
        self.Centre()       
    #-------------------------------------------------------------------------------------------

    def getCheckBoxState(self):
        try:
            return self.cbf.GetValue()
        except:
            return False
    #-------------------------------------------------------------------------------------------
                
    def onRemove(self, event):
        self.EndModal(wx.ID_REMOVE)
# - class DeleteRecordDialog(wx.Dialog):-----------------------------------------------------------
