#!/usr/bin/env python
#-*- coding: UTF-8 -*-
 
import wx
import os.path
from . import mumasqlite
from   .mumamisc import *


class UpdatePopup(wx.PopupTransientWindow):
    """  """
    def __init__(self, parent, infotext):
        wx.PopupTransientWindow.__init__(self, parent, style = wx.SIMPLE_BORDER)
        self.SetBackgroundColour("#C0C0E0")
        st = wx.StaticText(self, -1, infotext, pos = wx.Point(10,10))
        font = wx.Font(9, wx.TELETYPE, wx.NORMAL, wx.NORMAL)
        st.SetFont(font)
        sz = st.GetBestSize()
        self.SetSize(wx.Size(sz.width + 20, sz.height + 20))


class QueryInfoPopup(wx.PopupTransientWindow):
    """  """
    def __init__(self, parent, config, queryname):
        wx.PopupTransientWindow.__init__(self, parent, style = wx.SIMPLE_BORDER)
        self.SetBackgroundColour("#C0C0E0")
        querydata = config['Queries'][queryname]
        i0 = 'Query name:   %s\n\n' % (queryname)
        i1 = 'Parameter:    %s\n' % (str('%param%' in querydata['sql']))
        i2 = 'Join tables:  %s\n' % (querydata['join'])
        i3 = 'Display cols: %s\n' % (', '.join(querydata['columns']))
        i4 = 'Order by:     %s\n\n' % (', '.join(querydata['orderby']))
        if len(querydata['sql']) > 60:
            i5 = 'Sql string:   %s...' % (querydata['sql'][:60])
        else:
            i5 = 'Sql string:   %s' % (querydata['sql'])
        info = i0 + i1 + i2 + i3 + i4 + i5 
        
        st = wx.StaticText(self, -1, info, pos = wx.Point(10,10))
        font = wx.Font(9, wx.TELETYPE, wx.NORMAL, wx.NORMAL)
        st.SetFont(font)
        sz = st.GetBestSize()
        self.SetSize(wx.Size(sz.width + 20, sz.height + 20))


class PropertyPopup(wx.PopupTransientWindow):
    """  """
    FNF = 'file could not be found'
    QM  = '???'
    
    def __init__(self, parent, config, mumadb, id_title, playlists):
        wx.PopupTransientWindow.__init__(self, parent, style = wx.SIMPLE_BORDER)
        self.SetBackgroundColour("#C0C0E0")
        
        sql = "SELECT Title, Interpreter, Duration, Date, Code, Composer FROM muma_title WHERE Id_Title = %s" % (id_title)
        matches, count = mumadb.getMatches(sql)
        if count == 0: return
        match = matches[0]
        title = match[0]
        interpreter = match[1]
        duration = match[2]
        date = match[3]
        code = match[4]
        composer = match[5]

        i0 = 'Id_Title:     %s\n' % (id_title)
        i1 = 'Title:        %s\n' % (title)
        i2 = 'Interpreter:  %s\n' % (interpreter)
        i3 = 'Duration:     %s\n' % (duration)
        i4 = 'Date:         %s\n' % (date)
        i5 = 'Code:         %s\n' % (code)
        i6 = 'Composer:     %s\n\n' % (composer)

        found, path = findTitleExt(config, id_title)    
        if found:
            head, tail = os.path.splitext(path)
            i11 = 'File size:    %s Bytes\n' % (format3P(os.path.getsize(path)))
            i12 = 'File path:    %s' % (path)
            if config['Misc']['mutagenpresent'] == 'False':                
                i7 = 'Tag title:    %s\n' % ('no info because')
                i8 = 'Tag artist:   %s\n' % ('module mutagen')
                i9 = 'Tag album:    %s\n' % ('is not')
                i10 = 'Bitrate:      %s\n\n' % ('present')
            else:
                meta, ismp3, bitrate, dummyduration = getTagInfo(config, id_title)
                if 'title' in meta:
                    tagtitle = meta['title'][0]
                else:
                    tagtitle = self.QM
                if 'artist' in meta:
                    tagartist = meta['artist'][0]
                else:
                    tagartist = self.QM
                if 'album' in meta:
                    tagalbum = meta['album'][0]
                else:
                    tagalbum = self.QM
                i7 = 'Tag title:    %s\n' % (tagtitle)
                i8 = 'Tag artist:   %s\n' % (tagartist)
                i9 = 'Tag album:    %s\n' % (tagalbum)
                i10 = 'Bitrate:      %s bps\n\n' % (format3P(str(bitrate)))
        else:
            i7 = 'Tag title:    %s\n' % (self.FNF)
            i8 = 'Tag artist:   %s\n' % (self.FNF)
            i9 = 'Tag album:    %s\n' % (self.FNF)
            i10 = 'Bitrate:      %s\n\n' % (self.FNF)
            i11 = 'File size:    %s\n' % (self.FNF)
            i12= 'File path:    %s' % (self.FNF)
            
        info = i0 + i1 + i2 + i3 + i4 + i5 + i6 + i7 + i8 + i9 + i10 + i11 + i12
        info = info.replace('&', '&&')
        
        plstrs = []
        playlistnames = list(playlists.keys())
        playlistnames.sort()
        for playlistname in playlistnames:
            if id_title in playlists[playlistname]:
                plstrs.append(playlistname)
        
        if not len(plstrs): plstrs.append('---')
        plstr = '\n\nIn playlists: ' + '\n              '.join(plstrs)
        
        info += plstr
        st = wx.StaticText(self, -1, info, pos = wx.Point(10,10))
        font = wx.Font(9, wx.TELETYPE, wx.NORMAL, wx.NORMAL)
        st.SetFont(font)
        sz = st.GetBestSize()
        self.SetSize(wx.Size(sz.width + 20, sz.height + 20))
