#!/usr/bin/env python
#-*- coding: UTF-8 -*-

import wx

try:
    import treemixin 
except ImportError:
    from wx.lib.mixins import treemixin
    
from .mumamisc import *

class TreeCtrlWithMixin(treemixin.DragAndDrop, treemixin.ExpansionState, wx.TreeCtrl):
    def __init__(self, *args, **kwargs):
        self.moveItem = kwargs.pop('moveItem')
        super(TreeCtrlWithMixin, self).__init__(*args, **kwargs)
        self.CreateImageList()
    #-------------------------------------------------------------------------------------------

    def CreateImageList(self):
        imglist = wx.ImageList(16, 16, True, 4)
        self.fldridx = imglist.Add(wx.ArtProvider.GetBitmap(wx.ART_FOLDER, wx.ART_OTHER, wx.Size(16, 16)))
        self.fldropenidx = imglist.Add(wx.ArtProvider.GetBitmap(wx.ART_FILE_OPEN, wx.ART_OTHER, wx.Size(16, 16)))
        self.fileidx = imglist.Add(loadIcon('querydoc.png'))
        self.mfileidx = imglist.Add(loadIcon('audiofile.png'))
        self.AssignImageList(imglist)
    #-------------------------------------------------------------------------------------------

    def OnDrop(self, dropItem, dragItem):
        """ This function must be overloaded in the derived class.
        dragItem is the item being dragged by the user. dropItem is the
        item dragItem is dropped upon. If the user doesn't drop dragItem
        on another item, dropItem equals the (hidden) root item of the
        tree control. """
        dragindex = self.GetIndexOfItem(dragItem)
        dropindex = self.GetIndexOfItem(dropItem)
        if self.moveItem != None:
            self.moveItem(dragindex, dropindex)
# - class TreeCtrlWithMixin(wx.TreeCtrl, treemixin.ExpansionState):-----------------------------
        
